Bug 1654180 - RGW NFS Ganesha cannot be started without supplying path to keyring in init_args parameter to RGW FSAL defintion
Summary: RGW NFS Ganesha cannot be started without supplying path to keyring in init_a...
Keywords:
Status: CLOSED NOTABUG
Alias: None
Product: Red Hat Ceph Storage
Classification: Red Hat
Component: RGW
Version: 3.1
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: rc
: 3.*
Assignee: Matt Benjamin (redhat)
QA Contact: Tejas
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-11-28 08:05 UTC by Matthias Muench
Modified: 2019-08-15 13:29 UTC (History)
8 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-08-15 13:29:14 UTC
Target Upstream Version:


Attachments (Terms of Use)

Description Matthias Muench 2018-11-28 08:05:30 UTC
Description of problem:
Setting of `init_args = "--{arg}={arg-value}";` in RGW{} FSAL definition is not sufficient to properly start ganesha due to missing credentials. Instead, the path to keyring must be set to allow access of RGW FSAL to cluster.
With default setting, the startup of ganesha fails with messages:
28/11/2018 09:00:38 : epoch 5bfe4b26 : ceph31-rgw1.private-eval.local : ganesha.nfsd-2582[main] create_export :FSAL :CRIT :RGW module: librgw init failed (-5)
28/11/2018 09:00:38 : epoch 5bfe4b26 : ceph31-rgw1.private-eval.local : ganesha.nfsd-2582[main] mdcache_fsal_create_export :FSAL :MAJ :Failed to call create_export on underlying FSAL RGW
28/11/2018 09:00:38 : epoch 5bfe4b26 : ceph31-rgw1.private-eval.local : ganesha.nfsd-2582[main] fsal_cfg_commit :CONFIG :CRIT :Could not create export for (/) to (/)
28/11/2018 09:00:38 : epoch 5bfe4b26 : ceph31-rgw1.private-eval.local : ganesha.nfsd-2582[main] main :NFS STARTUP :WARN :No export entries found in configuration file !!!
28/11/2018 09:00:38 : epoch 5bfe4b26 : ceph31-rgw1.private-eval.local : ganesha.nfsd-2582[main] config_errs_to_log :CONFIG :CRIT :Config File (/etc/ganesha/ganesha.conf:11): 1 validation errors in block FSAL
28/11/2018 09:00:38 : epoch 5bfe4b26 : ceph31-rgw1.private-eval.local : ganesha.nfsd-2582[main] config_errs_to_log :CONFIG :CRIT :Config File (/etc/ganesha/ganesha.conf:11): Errors processing block (FSAL)
28/11/2018 09:00:38 : epoch 5bfe4b26 : ceph31-rgw1.private-eval.local : ganesha.nfsd-2582[main] config_errs_to_log :CONFIG :CRIT :Config File (/etc/ganesha/ganesha.conf:1): 1 validation errors in block EXPORT
28/11/2018 09:00:38 : epoch 5bfe4b26 : ceph31-rgw1.private-eval.local : ganesha.nfsd-2582[main] config_errs_to_log :CONFIG :CRIT :Config File (/etc/ganesha/ganesha.conf:1): Errors processing block (EXPORT)
28/11/2018 09:00:38 : epoch 5bfe4b26 : ceph31-rgw1.private-eval.local : ganesha.nfsd-2582[main] lower_my_caps :NFS STARTUP :EVENT :CAP_SYS_RESOURCE was successfully removed for proper quota management in FSAL


Version-Release number of selected component (if applicable): 
nfs-ganesha-2.5.5-100.el7cp.x86_64
nfs-ganesha-rgw-2.5.5-100.el7cp.x86_64

How reproducible: always


Steps to Reproduce:
1. take default configuration from docs for RGW FSAL definition in /etc/ganesha/ganesha.conf:
EXPORT
{
          Export_Id = 2; 
          Path = "/";
          Pseudo = "/";
          Access_Type = RW;
          SecType = "sys";
#          NFS_Protocols = 4;
#          Transport_Protocols = "TCP";
          Squash = "No_Root_Squash";
          FSAL {
                  Name = RGW;
                  User_Id = produser1;
                  Access_Key_Id ="k8aR0VcnTlVszUx2SmJB";
                  Secret_Access_Key = "AM2yE4LDpsAcGD20lqNph1k1umSyOo3aXFh2Ail4";
          } 
}
RGW {
          name = "client.rgw.ceph31-rgw1";
          ceph_conf = "/etc/ceph/ceph.conf";
          init_args = "--{arg}={arg-value}";
}

2. systemctl restart nfs-ganesha
3. observe messages in /var/log/ganesha/ganesha.log


Actual results:
28/11/2018 09:00:38 : epoch 5bfe4b26 : ceph31-rgw1.private-eval.local : ganesha.nfsd-2582[main] create_export :FSAL :CRIT :RGW module: librgw init failed (-5)
28/11/2018 09:00:38 : epoch 5bfe4b26 : ceph31-rgw1.private-eval.local : ganesha.nfsd-2582[main] mdcache_fsal_create_export :FSAL :MAJ :Failed to call create_export on underlying FSAL RGW
28/11/2018 09:00:38 : epoch 5bfe4b26 : ceph31-rgw1.private-eval.local : ganesha.nfsd-2582[main] fsal_cfg_commit :CONFIG :CRIT :Could not create export for (/) to (/)
28/11/2018 09:00:38 : epoch 5bfe4b26 : ceph31-rgw1.private-eval.local : ganesha.nfsd-2582[main] main :NFS STARTUP :WARN :No export entries found in configuration file !!!
28/11/2018 09:00:38 : epoch 5bfe4b26 : ceph31-rgw1.private-eval.local : ganesha.nfsd-2582[main] config_errs_to_log :CONFIG :CRIT :Config File (/etc/ganesha/ganesha.conf:11): 1 validation errors in block FSAL
28/11/2018 09:00:38 : epoch 5bfe4b26 : ceph31-rgw1.private-eval.local : ganesha.nfsd-2582[main] config_errs_to_log :CONFIG :CRIT :Config File (/etc/ganesha/ganesha.conf:11): Errors processing block (FSAL)
28/11/2018 09:00:38 : epoch 5bfe4b26 : ceph31-rgw1.private-eval.local : ganesha.nfsd-2582[main] config_errs_to_log :CONFIG :CRIT :Config File (/etc/ganesha/ganesha.conf:1): 1 validation errors in block EXPORT
28/11/2018 09:00:38 : epoch 5bfe4b26 : ceph31-rgw1.private-eval.local : ganesha.nfsd-2582[main] config_errs_to_log :CONFIG :CRIT :Config File (/etc/ganesha/ganesha.conf:1): Errors processing block (EXPORT)
28/11/2018 09:00:38 : epoch 5bfe4b26 : ceph31-rgw1.private-eval.local : ganesha.nfsd-2582[main] lower_my_caps :NFS STARTUP :EVENT :CAP_SYS_RESOURCE was successfully removed for proper quota management in FSAL


Expected results:
RGW Ganesha should figure out automatically proper location of keyring file for RGW, or documentation should be fixed.

Additional info:
Setting `init_args = "--keyring=/var/lib/ceph/radosgw/ceph-rgw.ceph31-rgw1/keyring";` fixes the problem.

Comment 3 Giridhar Ramaraju 2019-08-05 13:10:59 UTC
Updating the QA Contact to a Hemant. Hemant will be rerouting them to the appropriate QE Associate. 

Regards,
Giri

Comment 4 Giridhar Ramaraju 2019-08-05 13:12:01 UTC
Updating the QA Contact to a Hemant. Hemant will be rerouting them to the appropriate QE Associate. 

Regards,
Giri


Note You need to log in before you can comment on or make changes to this bug.